"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var addon_actions_1 = require("@storybook/addon-actions");
var addon_knobs_1 = require("@storybook/addon-knobs");
var react_1 = require("@storybook/react");
var react_2 = __importStar(require("react"));
var __1 = require("../");
var Empty = function (_a) {
    var intersecting = _a.intersecting, height = _a.height;
    return (react_2.default.createElement("div", { style: { height: height, background: intersecting ? 'lightgray' : 'whitesmoke' } }));
};
Empty.defaultProps = {
    height: '120vh',
};
var Text = function (_a) {
    var intersecting = _a.intersecting;
    return (react_2.default.createElement("h1", { style: { padding: '5rem 0', textAlign: 'center' } }, intersecting ? 'intersecting!!' : 'hiding'));
};
var Overview = function () {
    var target = react_2.useRef(null);
    var intersecting = __1.useIntersection(target, {
        rootMargin: addon_knobs_1.text('rootMargin', '0px'),
        threshold: addon_knobs_1.number('threshold', 0, { range: true, min: 0, max: 1, step: 0.01 }),
    }, addon_actions_1.action('onChange'));
    var empty = react_2.default.createElement(Empty, { intersecting: intersecting });
    return (react_2.default.createElement(react_2.default.Fragment, null,
        empty,
        react_2.default.createElement("div", { ref: target },
            react_2.default.createElement(Text, { intersecting: intersecting })),
        empty));
};
var WithThreshold = function () {
    var target = react_2.useRef(null);
    var intersecting = __1.useIntersection(target, {
        threshold: 0.8,
    }, addon_actions_1.action('onChange'));
    var empty = react_2.default.createElement(Empty, { intersecting: intersecting });
    return (react_2.default.createElement(react_2.default.Fragment, null,
        empty,
        react_2.default.createElement("div", { ref: target },
            react_2.default.createElement(Text, { intersecting: intersecting })),
        empty));
};
var WithRoot = function () {
    var root = react_2.useRef(null);
    var target = react_2.useRef(null);
    var intersecting = __1.useIntersection(target, {
        root: root,
        rootMargin: '100px',
    }, addon_actions_1.action('onChange'));
    var empty = react_2.default.createElement(Empty, { intersecting: intersecting, height: "500px" });
    return (react_2.default.createElement("div", { ref: root, style: {
            overflow: 'hidden scroll',
            height: 300,
        } },
        empty,
        react_2.default.createElement("div", { ref: target },
            react_2.default.createElement(Text, { intersecting: intersecting })),
        empty));
};
var WithOnce = function () {
    var target = react_2.useRef(null);
    var intersected = __1.useIntersection(target, {
        once: true,
    }, addon_actions_1.action('onChange'));
    var empty = react_2.default.createElement(Empty, { intersecting: intersected });
    return (react_2.default.createElement(react_2.default.Fragment, null,
        empty,
        react_2.default.createElement("div", { ref: target },
            react_2.default.createElement(Text, { intersecting: intersected })),
        empty));
};
var WithElement = function () {
    var _a = react_2.useState(null), target = _a[0], setTarget = _a[1];
    var intersected = __1.useIntersection(target, {}, addon_actions_1.action('onChange'));
    react_2.useEffect(function () {
        setTarget(document.getElementById('target'));
    }, []);
    var empty = react_2.default.createElement(Empty, { intersecting: intersected });
    return (react_2.default.createElement(react_2.default.Fragment, null,
        empty,
        react_2.default.createElement("p", { id: "target" }, "target"),
        react_2.default.createElement(Text, { intersecting: intersected }),
        empty));
};
react_1.storiesOf('useIntersection', module)
    .addDecorator(addon_knobs_1.withKnobs)
    .add('overview', function () { return react_2.default.createElement(Overview, null); })
    .add('with threshold (0.8)', function () { return react_2.default.createElement(WithThreshold, null); })
    .add('with root element and rootMargin (100px)', function () { return react_2.default.createElement(WithRoot, null); })
    .add('with once', function () { return react_2.default.createElement(WithOnce, null); })
    .add('with element', function () { return react_2.default.createElement(WithElement, null); });
